stages:
    - build
    - test
    - release
    - deploy

image: maven

build:
  stage: build
  script:
    - echo "Build application version ${CI_COMMIT_REF_SLUG} at ${CI_COMMIT_SHORT_SHA} commit"
    - echo "build successful"
  rules:
    - changes:
      - pom.xml

test on docker:
    stage: test
    script:
        - echo "Test ${CI_JOB_ID}"
        - mvn test
    tags:
        - docker

test on linux:
    stage: test
    script:
        - echo "Test ${CI_JOB_ID}"
        - mvn test
    tags:
        - linux

release:
    stage: release
    script: mvn package

deploy to dev:
    stage: deploy
    script:
        - echo 'deploying to dev...'
    when: manual

deploy to prod:
    stage: deploy
    script:
        - echo 'deploying to prod...'
    when: manual
    only:
      refs:
        - main
        - tags
